/*
============================================================================
 Name        : DarkSidePlayerAdapter.h
 Author      : 
 Version     :
 Copyright   : Your copyright notice
 Description : CDarkSidePlayerAdapter declaration
============================================================================
*/

#ifndef DarkSidePlayerAdapter_H
#define DarkSidePlayerAdapter_H

// INCLUDES
#include <e32std.h>
#include <e32base.h>
#include <MdaAudioSamplePlayer.h>


// CLASS DECLARATION

/**
*  CDarkSidePlayerAdapter
* 
*/
class CDarkSidePlayerAdapter : public CBase, public MMdaAudioPlayerCallback 
{
public: // Constructors and destructor

	/**
        * Destructor.
        */
	~CDarkSidePlayerAdapter();

        /**
        * Two-phased constructor.
        */
	static CDarkSidePlayerAdapter* NewL(const TDesC16& aFilename);

        /**
        * Two-phased constructor.
        */
	static CDarkSidePlayerAdapter* NewLC(const TDesC16& aFilename);
	
	void PlayL ();
	
	void StopL ();
	
	void MapcInitComplete(TInt aError, const TTimeIntervalMicroSeconds& aDuration);
	void MapcPlayComplete(TInt aError);

private:

	/**
        * Constructor for performing 1st stage construction
        */
	CDarkSidePlayerAdapter();

	/**
        * EPOC default constructor for performing 2nd stage construction
        */
	void ConstructL(const TDesC16& aFilename);
	
	TBool iFreeToPrepare;
	TBool iFreeToPlay;
	CMdaAudioPlayerUtility* iMdaAudioPlayerUtility;

};

#endif // DarkSidePlayerAdapter_H
