#ifndef DARKSIDETETRIS_H_
#define DARKSIDETETRIS_H_

#include <e32base.h>


#define DS_GAMETABLE_WIDTH 10
#define DS_GAMETABLE_HEIGHT 25

// Global states

enum EGlobalStates {
	DS_GAMESTATE_TITLESCREEN = 1,
	DS_GAMESTATE_PLAYING,
	DS_GAMESTATE_GAMEOVER,
	DS_GAMESTATE_HIGHSCORES
};

// Game timings

#define DS_LEVEL_UPDATE_INTERVAL (25 * 1000 * 1000)

// Game table

#define DS_FIRST_VISIBLE_ROW 3

// Blocks

#define DS_BLOCK_TYPE_COUNT 9
#define DS_BLOCK_SIZE 9

enum EBlocks {
  DS_BLOCK_RED = 1,
  DS_BLOCK_BLUE = 2,
  DS_BLOCK_CYAN = 3,
  DS_BLOCK_MAGENTA = 4,
  DS_BLOCK_YELLOW = 5,
  DS_BLOCK_ORANGE = 6,
  DS_BLOCK_GREEN = 7,
  DS_BLOCK_WHITE = 8,
  DS_BLOCK_GREY = 9,
};

// Stones

#define DS_BLOCKSINSTONE_COUNT 4
#define DS_STONE_TYPE_COUNT 7

enum EStoneTypes {
  DS_STONE_ORANGE_SQUARE = 1,
  DS_STONE_RED_STICK = 2,
  DS_STONE_BLUE_CORNER = 3,
  DS_STONE_GREEN_CORNER = 4,
  DS_STONE_PINK_CURVE = 5,
  DS_STONE_YELLOW_CURVE = 6,
  DS_STONE_CYAN_CROSSING = 7
};

// Scoring

#define DS_POINTS_NEW_STONE 5
#define DS_POINTS_MOVE_DOWN 1
#define DS_POINTS_CLEAR_ROW 100
#define DS_POINTS_CLEAR_2ROWS 250
#define DS_POINTS_CLEAR_3ROWS 400
#define DS_POINTS_CLEAR_4ROWS 1000

#include "DarkSidePlayerAdapter.h"
#include "Stone.h"
#include "StoneGenerator.h"
#include "Score.h"
#include "ScoreBoard.h"
#include "GameTable.h"
#include "GameState.h"

#endif /*DARKSIDETETRIS_H_*/
