/*
============================================================================
 Name        : DarkSideTetrisAppUi.h
 Author      : 
 Copyright   : Your copyright notice
 Description : Declares UI class for application.
============================================================================
*/

#ifndef DARKSIDETETRISAPPUI_H
#define DARKSIDETETRISAPPUI_H

// INCLUDES
#include <aknappui.h>
#include "DarkSideTetris.h"

// FORWARD DECLARATIONS
class CDarkSideTetrisContainer;


// CLASS DECLARATION

/**
* Application UI class.
* Provides support for the following features:
* - EIKON control architecture
*
*/
class CDarkSideTetrisAppUi : public CAknAppUi
    {
    public: // // Constructors and destructor

        /**
        * EPOC default constructor.
        */
        void ConstructL();

        /**
        * Destructor.
        */
        ~CDarkSideTetrisAppUi();

    public: // New functions

    public: // Functions from base classes

    private:
        // From MEikMenuObserver
        void DynInitMenuPaneL(TInt aResourceId,CEikMenuPane* aMenuPane);

    private:
        /**
        * From CEikAppUi, takes care of command handling.
        * @param aCommand command to be handled
        */
        void HandleCommandL(TInt aCommand);

        /**
        * From CEikAppUi, handles key events.
        * @param aKeyEvent Event to handled.
        * @param aType Type of the key event.
        * @return Response code (EKeyWasConsumed, EKeyWasNotConsumed).
        */
        virtual TKeyResponse HandleKeyEventL(
            const TKeyEvent& aKeyEvent,TEventCode aType);

    private: //Data
        CDarkSideTetrisContainer* iAppContainer;
        CGameState* iGameState;
        CDarkSidePlayerAdapter* iStartGameSound;
        
    };

#endif


