/*
============================================================================
 Name        : Score.h
 Author      : 
 Version     :
 Copyright   : Your copyright notice
 Description : CScore declaration
============================================================================
*/

#ifndef Score_H
#define Score_H

// INCLUDES
#include <e32std.h>
#include <e32base.h>
#include <s32std.h>

// CLASS DECLARATION

/**
*  CScore
* 
*/
class CScore : public CBase
{
public: // Constructors and destructor

	/**
        * Destructor.
        */
	~CScore();

        /**
        * Two-phased constructor.
        */
	static CScore* NewL();

        /**
        * Two-phased constructor.
        */
	static CScore* NewLC();
	
	void ExternalizeL (RWriteStream& aStream);
	void InternalizeL (RReadStream& aStream);	

	TBuf<6> iName;
	TInt16 iPoints;

private:

	/**
        * Constructor for performing 1st stage construction
        */
	CScore();

	/**
        * EPOC default constructor for performing 2nd stage construction
        */
	void ConstructL();

};

#endif // Score_H
