/*
============================================================================
 Name        : ScoreBoard.h
 Author      : 
 Version     :
 Copyright   : Your copyright notice
 Description : CScoreBoard declaration
============================================================================
*/

#ifndef ScoreBoard_H
#define ScoreBoard_H

// INCLUDES
#include <e32std.h>
#include <e32base.h>

class RFs;

// CLASS DECLARATION

/**
*  CScoreBoard
* 
*/
class CScoreBoard : public CBase
{
public: // Constructors and destructor

	/**
        * Destructor.
        */
	~CScoreBoard();

        /**
        * Two-phased constructor.
        */
	static CScoreBoard* NewL();

        /**
        * Two-phased constructor.
        */
	static CScoreBoard* NewLC();
	
	void LoadL ();
	void SaveL ();	

	void AddScore (CScore* aNewScore);
	CScore* GetScore (TInt8 aIndex);
	TInt8 GetScoreCount ();
	

private:

	/**
        * Constructor for performing 1st stage construction
        */
	CScoreBoard();

	/**
        * EPOC default constructor for performing 2nd stage construction
        */
	void ConstructL();
	
	RPointerArray<CScore> iScores;
	
};

#endif // ScoreBoard_H
