#ifndef _STONE_H
#define _STONE_H

class CGameTable;

class CStone
{
private:
    TInt8 blockCount;
    TInt8 code;
    CGameTable* iGameTable;
    TBool uglyCheck;
    TInt blockX[DS_BLOCKSINSTONE_COUNT];
    TInt blockY[DS_BLOCKSINSTONE_COUNT];

public:
    CStone();
    CStone(TInt8 aStoneCode);
    virtual ~CStone();
    void AddBlock(TInt8 aX, TInt8 aY);
    TBool Contains(TInt8 aX, TInt8 aY);
    void Drop();
    void DropLeft();
    void DropRight();
    void Empty();
    TInt8 GetBlock(TInt8 aIndex);
    TInt8 GetBlockX(TInt8 aIndex);
    TInt8 GetBlockY(TInt8 aIndex);
    TBool MoveDown(TBool aTest);
    TBool MoveLeft(TBool aTest);
    TBool MoveRight(TBool aTest);
    TBool RotateLeft(TBool aTest);
    TBool RotateRight(TBool aTest);
    TInt8 GetBlockCount() const;
    void SetCode(TInt8 aCode);
    TInt8 GetCode() const;
    CGameTable* GetGameTable() const;
    void SetGameTable(CGameTable* aGameTable);
};

#endif // ndef _STONE_H

#ifndef _STONE_H_INLINES
#define _STONE_H_INLINES

inline TInt8 CStone::GetBlockCount() const
{
  return blockCount;
}

inline void CStone::SetCode(TInt8 aCode)
{
  code = aCode;
}

inline TInt8 CStone::GetCode() const
{
  return code;
}

inline CGameTable* CStone::GetGameTable() const
{
  return iGameTable;
}

inline void CStone::SetGameTable(CGameTable* aGameTable)
{
  iGameTable = aGameTable;
}

#endif // ndef _STONE_H_INLINES
