/*
============================================================================
 Name        : DarkSidePlayerAdapter.cpp
 Author      : 
 Version     :
 Copyright   : (C) Dan Bogdanov 2006
 Description : CDarkSidePlayerAdapter implementation
============================================================================
*/

#include <MdaAudioSamplePlayer.h>
#include "DarkSideTetris.h"


CDarkSidePlayerAdapter::CDarkSidePlayerAdapter()
{
	// No implementation required
}


CDarkSidePlayerAdapter::~CDarkSidePlayerAdapter()
{
	delete iMdaAudioPlayerUtility;
}

CDarkSidePlayerAdapter* CDarkSidePlayerAdapter::NewLC(const TDesC16& aFilename)
{
	CDarkSidePlayerAdapter* self = new (ELeave)CDarkSidePlayerAdapter();
	CleanupStack::PushL(self);
	self->ConstructL(aFilename);
	return self;
}

CDarkSidePlayerAdapter* CDarkSidePlayerAdapter::NewL(const TDesC16& aFilename)
{
	CDarkSidePlayerAdapter* self=CDarkSidePlayerAdapter::NewLC(aFilename);
	CleanupStack::Pop(); // self;
	return self;
}

void CDarkSidePlayerAdapter::ConstructL(const TDesC16& aFilename)
{
   iMdaAudioPlayerUtility = CMdaAudioPlayerUtility::NewFilePlayerL(aFilename, *this);
}

void CDarkSidePlayerAdapter::PlayL()
{
	if(iFreeToPlay) {
		iFreeToPlay = FALSE;
		iMdaAudioPlayerUtility->Play();
	}
}
void CDarkSidePlayerAdapter::StopL()
{
	iMdaAudioPlayerUtility->Stop();
}

void CDarkSidePlayerAdapter::MapcInitComplete(TInt /*aError*/, const TTimeIntervalMicroSeconds& /*aDuration*/)
{
	iFreeToPlay = TRUE;
}

void CDarkSidePlayerAdapter::MapcPlayComplete(TInt /*aError*/)
{
	iFreeToPlay = TRUE;
}

