#include "DarkSideTetris.h"

CGameState::CGameState () {
	iGlobalState = DS_GAMESTATE_TITLESCREEN;
	iNextStoneCode = iStoneGenerator->BuildRandomCode ();
}

CGameState::~CGameState () {
	delete iGameTable;	
	delete iStoneGenerator;	
	delete iScoreBoard;	
}

CGameState* CGameState::NewL() {
	CGameState* self = new CGameState ();
	CleanupStack::PushL (self);
	self->ConstructL ();
	CleanupStack::Pop ();
	return self;
}

void CGameState::ConstructL () {
	iGameTable = CGameTable::NewL ();
	iStoneGenerator = CStoneGenerator::NewL ();
	iScoreBoard = CScoreBoard::NewL ();
}
				

void CGameState::NextFrame () {
	TTime currentTime;
	currentTime.HomeTime();
	TInt64 currentTick = currentTime.Int64();
	UpdateLocalPlayer (currentTick);
}

void CGameState::UpdateLocalPlayer (TTime aCurrentTime) {


	if (iGlobalState == DS_GAMESTATE_PLAYING) {

		TBool bottom = EFalse;
		if (iGameTable->GetCurrentStone () != 0)
			bottom = !iGameTable->GetCurrentStone ()->MoveDown (ETrue);

		if (iGameTable->GetCurrentStone () == 0 || bottom) {
	        
			iGameTable->SetCurrentStone (0);

			iGameTable->CheckRows();
	  
			CStone* iNextStone = iStoneGenerator->Build(iNextStoneCode);
			iNextStoneCode = iStoneGenerator->BuildRandomCode ();
			
			if (!iGameTable->SetCurrentStone(iNextStone)) {
				iGameTable->SetCurrentStone (0);
				iGlobalState = DS_GAMESTATE_GAMEOVER;
				CScore* score = CScore::NewL ();
				score->iName = iPlayerName;
				score->iPoints = iGameTable->GetScore();				
				iScoreBoard->AddScore (score),
				iScoreBoard->SaveL();				
				return;
			    
			}
			iGameTable->AddToScore (DS_POINTS_NEW_STONE);


		}
		if (iGameTable->GetCurrentStone ()) {
			iGameTable->GetCurrentStone ()->MoveDown (false);
		}

		if (aCurrentTime > iGameTable->iNextLevelUpdateTime) {
			
			TTimeIntervalMicroSeconds sec;
			sec = DS_LEVEL_UPDATE_INTERVAL;
			iGameTable->iNextLevelUpdateTime = iGameTable->iNextLevelUpdateTime + sec;
			iGameTable->NextLevel ();
		}
	}	
}